传送门
文章目录
- 题意:
- 思路:
题意:
思路:
直接考虑比较难想,这种公式题基本都是将部分答案看成一个整体,考虑xi,xi+1x_i,x_{i+1}xi,xi+1的贡献的。
假设当前的xi=x,xi+1=y,x<yx_i=x,x_{i+1}=y,x<yxi=x,xi+1=y,x<y,分以下几种情况讨论:
(1)[1,x−1],[y+1,n](1)[1,x-1],[y+1,n](1)[1,x−1],[y+1,n],这两段区间由于将某个数提前对答案没有影响,所以贡献为y−xy-xy−x。
(2)[x+1,y−1](2)[x+1,y-1](2)[x+1,y−1],这段区间由于将答案之间的数抽去了一个,所以贡献为y−x−1y-x-1y−x−1。
(3)[x,x](3)[x,x](3)[x,x],将xxx提前,贡献为y−1y-1y−1。
(4)[y,y](4)[y,y](4)[y,y],将yyy提前,贡献为xxx。
直接差分一下即可,当然也可以用线段树但是没必要。
// Problem: E. Special Permutations
// Contest: Codeforces - Codeforces Round #590 (Div. 3)
// URL: https://codeforces.com/contest/1234/problem/E
// Memory Limit: 256 MB
// Time Limit: 2000 ms
//
// Powered by CP Editor (https://cpeditor.org)//#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,fast-math")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,avx,avx2,popcnt,tune=native")
//#pragma GCC optimize(2)
#include<cstdio>
#include<iostream>
#include<string>
#include<cstring>
#include<map>
#include<cmath>
#include<cctype>
#include<vector>
#include<set>
#include<queue>
#include<algorithm>
#include<sstream>
#include<ctime>
#include<cstdlib>
#include<random>
#include<cassert>
#define X first
#define Y second
#define L (u<<1)
#define R (u<<1|1)
#define pb push_back
#define mk make_pair
#define Mid ((tr[u].l+tr[u].r)>>1)
#define Len(u) (tr[u].r-tr[u].l+1)
#define random(a,b) ((a)+rand()%((b)-(a)+1))
#define db puts("---")
using namespace std;//void rd_cre() { freopen("d://dp//data.txt","w",stdout); srand(time(NULL)); }
//void rd_ac() { freopen("d://dp//data.txt","r",stdin); freopen("d://dp//AC.txt","w",stdout); }
//void rd_wa() { freopen("d://dp//data.txt","r",stdin); freopen("d://dp//WA.txt","w",stdout); }typedef long long LL;
typedef unsigned long long ULL;
typedef pair<int,int> PII;const int N=1000010,mod=1e9+7,INF=0x3f3f3f3f;
const double eps=1e-6;int n,m;
int a[N];
LL ans[N];void add(int l,int r,int add) {if(l>r) return;ans[l]+=add; ans[r+1]-=add;
}int main()
{
// ios::sync_with_stdio(false);
// cin.tie(0);cin>>n>>m;for(int i=1;i<=m;i++) scanf("%d",&a[i]);for(int i=2;i<=m;i++) {int x=a[i-1],y=a[i];if(x==y) continue;if(x>y) swap(x,y);add(1,x-1,y-x); add(y+1,n,y-x);add(x+1,y-1,y-x-1);add(x,x,y-1); add(y,y,x);}for(int i=1;i<=n;i++) ans[i]+=ans[i-1];for(int i=1;i<=n;i++) printf("%lld ",ans[i]);return 0;
}
/**/